/*
 * STRUMPACK -- STRUctured Matrices PACKage, Copyright (c) 2014, The Regents of
 * the University of California, through Lawrence Berkeley National Laboratory
 * (subject to receipt of any required approvals from the U.S. Dept. of Energy).
 * All rights reserved.
 *
 * If you have questions about your rights to use or distribute this software,
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 *
 * NOTICE. This software is owned by the U.S. Department of Energy. As such, the
 * U.S. Government has been granted for itself and others acting on its behalf a
 * paid-up, nonexclusive, irrevocable, worldwide license in the Software to
 * reproduce, prepare derivative works, and perform publicly and display publicly.
 * Beginning five (5) years after the date permission to assert copyright is
 * obtained from the U.S. Department of Energy, and subject to any subsequent five
 * (5) year renewals, the U.S. Government is granted for itself and others acting
 * on its behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
 * Software to reproduce, prepare derivative works, distribute copies to the
 * public, perform publicly and display publicly, and to permit others to do so.
 *
 * Developers: Francois-Henry Rouet, Xiaoye S. Li, Pieter Ghysels
 *             (Lawrence Berkeley National Lab, Computational Research Division).
 *
 */

#ifndef STRUMPACK_DENSE_PACKAGE_HPP
#define STRUMPACK_DENSE_PACKAGE_HPP

#define STRUMPACK_CPP

/* Base header that includes everything in the right order */

/* Standard libraries */
#include<cstdlib>
#include<ctime>
#include<complex>
#include<sstream>
#include<iostream>
#include<iomanip>
#include<typeinfo>
#if defined(RANDGEN)
#include<random>
#endif

/* MPI */
#include"mpi.h"

/* STRUMPACK */
#include "constants.h"
extern "C" {
  #include "blacs.h"
  #include "blas.h"
  #include "lapack.h"
  #include "scalapack.h"
}
#include "blas.hpp"
#include "lapack.hpp"
#include "scalapack.hpp"
#include "MemoryTracker.hpp"
#include "StrumpackRand.hpp"
#include "tools.hpp"
#include "par_tools.hpp"
#include "Partition_tree.hpp"
#include "HSS_tree.hpp"
#include "HSS_par_tools.hpp"
#include "seq_genHMatrix.hpp"
#include "par_genHMatrix.hpp"
#include "seq_MGSInterpol.hpp"
#include "par_MGSInterpol.hpp"
#include "seq_HQRInterpol.hpp"
#include "par_HQRInterpol.hpp"
#include "HSSR_seq_Compress.hpp"
#include "HSSR_par_Compress.hpp"
#include "HSS_seq_Product.hpp"
#include "HSS_par_Product.hpp"
#include "HSS_seq_ULV.hpp"
#include "HSS_par_ULV.hpp"
#include "HSS_seq_Solve.hpp"
#include "HSS_par_Solve.hpp"
#include "HSS_seq_Extraction.hpp"
#include "HSS_par_Extraction.hpp"
#include "HSS_seq_GenerateSchur.hpp"
#include "HSS_par_GenerateSchur.hpp"
#include "StrumpackDensePackage_CPP.hpp"

#endif // STRUMPACK_DENSE_PACKAGE_HPP
